<!DOCTYPE html>

<html>
<head>
  <title>ContextParticipant</title>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8">
  <meta name="viewport" content="width=device-width, target-densitydpi=160dpi, initial-scale=1.0; maximum-scale=1.0; user-scalable=0;">
  <link rel="stylesheet" media="all" href="../../../../docco.css" />
</head>
<body>
  <div id="container">
    <div id="background"></div>
    
      <ul id="jump_to">
        <li>
          <a class="large" href="javascript:void(0);">Jump To &hellip;</a>
          <a class="small" href="javascript:void(0);">+</a>
          <div id="jump_wrapper">
          <div id="jump_page_wrapper">
            <div id="jump_page">
              
                
                <a class="source" href="App.html">
                  src/main/java/JavaContextParticipant/App.java
                </a>
              
                
                <a class="source" href="RootCmd.html">
                  src/main/java/JavaContextParticipant/RootCmd.java
                </a>
              
                
                <a class="source" href="Seacow.html">
                  src/main/java/JavaContextParticipant/Seacow.java
                </a>
              
            </div>
          </div>
        </li>
      </ul>
    
    <ul class="sections">
        
        
        
        <li id="section-1">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-1">&#182;</a>
              </div>
              <h1 id="contextparticipant">ContextParticipant</h1>
<p>This file contains a method for each example/use-case case.</p>
<ul>
<li>For general information about gRPC see <a href="https://grpc.io/docs/guides/">https://grpc.io/docs/guides/</a>.</li>
<li>For information about the Java implementation of gRPC see <a href="https://grpc.io/docs/tutorials/basic/java.html">https://grpc.io/docs/tutorials/basic/java.html</a>.</li>
<li>For API docs on the HTTP mapping see <a href="http://api.seacow.sirenia.eu">http://api.seacow.sirenia.eu</a>.</li>
</ul>

            </div>
            
            <div class="content"><div class='highlight'><pre>

<span class="hljs-keyword">package</span> JavaContextParticipant;

<span class="hljs-keyword">import</span> JavaContextParticipant.RequestQueue.ActualRequestQueueItem;
<span class="hljs-keyword">import</span> JavaContextParticipant.RequestQueue.RequestQueueItem;
<span class="hljs-keyword">import</span> JavaContextParticipant.RequestQueue.TerminalRequestQueueItem;
<span class="hljs-keyword">import</span> io.grpc.stub.StreamObserver;
<span class="hljs-keyword">import</span> picocli.CommandLine;
<span class="hljs-keyword">import</span> seacow.ContextActionGrpc;
<span class="hljs-keyword">import</span> seacow.ContextDataGrpc;
<span class="hljs-keyword">import</span> seacow.ContextManagerGrpc;
<span class="hljs-keyword">import</span> seacow.RegistryGrpc;

<span class="hljs-keyword">import</span> java.util.Map;
<span class="hljs-keyword">import</span> java.util.concurrent.LinkedTransferQueue;
<span class="hljs-keyword">import</span> java.util.logging.Logger;</pre></div></div>
            
        </li>
        
        
        <li id="section-2">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-2">&#182;</a>
              </div>
              <p>The <code>RootCmd</code> delegates to its list of sub-commands implemented as <code>@CommandLine.Command</code> annotated methods.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre><span class="hljs-meta">@CommandLine</span>.Command(mixinStandardHelpOptions = <span class="hljs-keyword">true</span>)
<span class="hljs-keyword">public</span> <span class="hljs-class"><span class="hljs-keyword">class</span> <span class="hljs-title">RootCmd</span> <span class="hljs-keyword">implements</span> <span class="hljs-title">Runnable</span> </span>{

    <span class="hljs-keyword">private</span> <span class="hljs-keyword">static</span> <span class="hljs-keyword">final</span> Logger logger = Logger.getLogger(RootCmd.class.getName());</pre></div></div>
            
        </li>
        
        
        <li id="section-3">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-3">&#182;</a>
              </div>
              <p>The host of the server we’ll connect to.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>    <span class="hljs-meta">@CommandLine</span>.Option(names = {<span class="hljs-string">"--host"</span>}, description = <span class="hljs-string">"The host to connect to"</span>, defaultValue = <span class="hljs-string">"localhost"</span>)
    <span class="hljs-keyword">private</span> String host;</pre></div></div>
            
        </li>
        
        
        <li id="section-4">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-4">&#182;</a>
              </div>
              <p>The port property determines which port we’re connecting to.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>    <span class="hljs-meta">@CommandLine</span>.Option(names = {<span class="hljs-string">"-p"</span>, <span class="hljs-string">"--port"</span>}, description = <span class="hljs-string">"The port to connect to"</span>, defaultValue = <span class="hljs-string">"9000"</span>)
    <span class="hljs-keyword">private</span> <span class="hljs-keyword">int</span> port;</pre></div></div>
            
        </li>
        
        
        <li id="section-5">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-5">&#182;</a>
              </div>
              <h2 id="registry-examples">Registry examples</h2>

            </div>
            
        </li>
        
        
        <li id="section-6">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-6">&#182;</a>
              </div>
              <h3 id="list-actions">List actions</h3>
<p>This service is invoked to list the actions available on the service instance which you’ve connected to.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>    <span class="hljs-meta">@CommandLine</span>.Command(mixinStandardHelpOptions = <span class="hljs-keyword">true</span>)
    <span class="hljs-function"><span class="hljs-keyword">public</span> <span class="hljs-keyword">void</span> <span class="hljs-title">ListActions</span><span class="hljs-params">()</span> </span>{</pre></div></div>
            
        </li>
        
        
        <li id="section-7">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-7">&#182;</a>
              </div>
              <p>First, we’ll need to obtain a client for the registry service.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        RegistryGrpc.RegistryBlockingStub registry = <span class="hljs-keyword">new</span> Seacow(host, port).getRegistry();</pre></div></div>
            
        </li>
        
        
        <li id="section-8">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-8">&#182;</a>
              </div>
              <p>Next, we’ll invoke the <code>LocalActions</code> method with a very sparse request.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        .LocalActionsResponse lar = registry.localActions(.LocalActionsRequest.newBuilder().build());</pre></div></div>
            
        </li>
        
        
        <li id="section-9">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-9">&#182;</a>
              </div>
              <p>Go through the received actions</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        <span class="hljs-keyword">for</span> (.LocalAction la : lar.getActionsList()) {</pre></div></div>
            
        </li>
        
        
        <li id="section-10">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-10">&#182;</a>
              </div>
              <p>Log out each action</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>            logger.info(la.toString());
        }
    }</pre></div></div>
            
        </li>
        
        
        <li id="section-11">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-11">&#182;</a>
              </div>
              <h3 id="list-items-of-a-specific-type">List items of a specific type</h3>
<p>This can be used to figure out which ContextManager to connect to. Normally a Manatee will only run one instance
but it will spawn more if multiple applications of the same type are discovered.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>    <span class="hljs-meta">@CommandLine</span>.Command(mixinStandardHelpOptions = <span class="hljs-keyword">true</span>)
    <span class="hljs-function"><span class="hljs-keyword">public</span> <span class="hljs-keyword">void</span> <span class="hljs-title">OfType</span><span class="hljs-params">(@CommandLine.Option(names = {<span class="hljs-string">"--typename"</span>}, defaultValue = <span class="hljs-string">"ContextManager"</span>)</span> String typename) </span>{
        RegistryGrpc.RegistryBlockingStub registry = <span class="hljs-keyword">new</span> Seacow(host, port).getRegistry();</pre></div></div>
            
        </li>
        
        
        <li id="section-12">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-12">&#182;</a>
              </div>
              <p>We invoke the <code>OfType</code> method and supply the <code>typename</code>. Currently only “ContextManager” is allowed for Manatee requests.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        .OfTypeResponse otr = registry.ofType(.OfTypeRequest.newBuilder().setTypeName(typename).build());</pre></div></div>
            
        </li>
        
        
        <li id="section-13">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-13">&#182;</a>
              </div>
              <p>The response is a collection of identifiers (strings)</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        <span class="hljs-keyword">for</span> (String id : otr.getIdentifiersList()) {</pre></div></div>
            
        </li>
        
        
        <li id="section-14">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-14">&#182;</a>
              </div>
              <p>For each identifier we fetch a bit more information and log out the result.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>            .ComponentByIDResponse cbir = registry.componentByID(.ComponentByIDRequest.newBuilder().setIdentifier(id).build());
            logger.info(cbir.toString());
        }
    }</pre></div></div>
            
        </li>
        
        
        <li id="section-15">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-15">&#182;</a>
              </div>
              <h2 id="contextmanager-examples">ContextManager examples</h2>

            </div>
            
        </li>
        
        
        <li id="section-16">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-16">&#182;</a>
              </div>
              <h3 id="join-a-context-session">Join a context session</h3>
<p>As a context participant you can join a session to</p>
<ul>
<li>participate in context synchronization,</li>
<li>act as a context agent to perform actions,</li>
<li>or request another agent to perform a given action.</li>
</ul>
<p>When joining a session you need to first decide how to requests coming from the context manager.
This involves choosing the protocol on which your participant is reachable. For this example we’ll use a gRPC
stream to allow the context manager to contact us.</p>
<p>Other options include:</p>
<ul>
<li>running a HTTP server and implementing the context participant,</li>
<li>connecting via a WebSocket and responding to the JSON-RPC invocations channeled here.</li>
</ul>

            </div>
            
            <div class="content"><div class='highlight'><pre>    <span class="hljs-meta">@CommandLine</span>.Command(mixinStandardHelpOptions = <span class="hljs-keyword">true</span>)
    <span class="hljs-function"><span class="hljs-keyword">public</span> <span class="hljs-keyword">void</span> <span class="hljs-title">JoinCommonContext</span><span class="hljs-params">(
            @CommandLine.Option(
                    names = {<span class="hljs-string">"--componentId"</span>},
                    required = <span class="hljs-keyword">true</span>,
                    description = <span class="hljs-string">"The id of the context manager to join"</span>
            )</span> String componentId,
            @CommandLine.<span class="hljs-title">Option</span><span class="hljs-params">(
                    names = {<span class="hljs-string">"--applicationName"</span>},
                    required = <span class="hljs-keyword">true</span>,
                    description = <span class="hljs-string">"The name identifying the application. This should be an identifier from the CMR."</span>
            )</span> String applicationName,
            @CommandLine.<span class="hljs-title">Option</span><span class="hljs-params">(names = {<span class="hljs-string">"--survey"</span>}, defaultValue = <span class="hljs-string">"true"</span>)</span>
            <span class="hljs-keyword">boolean</span> shouldSurvey,
            @CommandLine.<span class="hljs-title">Option</span><span class="hljs-params">(names = {<span class="hljs-string">"--wait"</span>}, defaultValue = <span class="hljs-string">"true"</span>)</span>
            <span class="hljs-keyword">boolean</span> shouldWait
    ) <span class="hljs-keyword">throws</span> InterruptedException </span>{</pre></div></div>
            
        </li>
        
        
        <li id="section-17">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-17">&#182;</a>
              </div>
              <p>Get access to the async context manager stub</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        ContextManagerGrpc.ContextManagerStub asyncStub = <span class="hljs-keyword">new</span> Seacow(host, port).getContextManagerAsync();</pre></div></div>
            
        </li>
        
        
        <li id="section-18">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-18">&#182;</a>
              </div>
              <p>Initialize a  queue to handle streaming responses</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        <span class="hljs-keyword">final</span> LinkedTransferQueue&lt;RequestQueueItem&gt; requestQueue = <span class="hljs-keyword">new</span> LinkedTransferQueue&lt;&gt;();</pre></div></div>
            
        </li>
        
        
        <li id="section-19">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-19">&#182;</a>
              </div>
              <p>Start observing the stream. Normally we’d care about the return value, but not in this example.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        <span class="hljs-keyword">final</span> StreamObserver&lt;.ContextParticipantStreamRequest&gt; stream = asyncStub.contextParticipantStream(<span class="hljs-keyword">new</span> StreamObserver&lt;.ContextParticipantStreamResponse&gt;() {
            <span class="hljs-meta">@Override</span>
            <span class="hljs-function"><span class="hljs-keyword">public</span> <span class="hljs-keyword">void</span> <span class="hljs-title">onNext</span><span class="hljs-params">(.ContextParticipantStreamResponse value)</span> </span>{</pre></div></div>
            
        </li>
        
        
        <li id="section-20">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-20">&#182;</a>
              </div>
              <p>The server will send us a variety of messages, setup a switch to handle each type of message</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                <span class="hljs-keyword">switch</span> (value.getContentCase()) {</pre></div></div>
            
        </li>
        
        
        <li id="section-21">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-21">&#182;</a>
              </div>
              <p>In case we get a reply to our join request.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                    <span class="hljs-keyword">case</span> JOIN_COMMON_CONTEXT:</pre></div></div>
            
        </li>
        
        
        <li id="section-22">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-22">&#182;</a>
              </div>
              <p>We simply log out the details.
For a proper implementation we’d need to keep the <code>ParticipantCoupon</code> for further interactions with the context manager.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                        .JoinCommonContextResponse join = value.getJoinCommonContext();
                        logger.info(<span class="hljs-string">"Joined: "</span> + join.toString());
                        <span class="hljs-keyword">break</span>;</pre></div></div>
            
        </li>
        
        
        <li id="section-23">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-23">&#182;</a>
              </div>
              <p><em>Note</em> that the context manager expects a timely reply on some of these methods.
If a reply is not received by the context manager it may choose to disconnect the stream.</p>

            </div>
            
        </li>
        
        
        <li id="section-24">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-24">&#182;</a>
              </div>
              <p>A reply for <code>CONTEXT_CHANGES_PENDING</code> is expected and we simple always provide an “accept”.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                    <span class="hljs-keyword">case</span> CONTEXT_CHANGES_PENDING:</pre></div></div>
            
        </li>
        
        
        <li id="section-25">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-25">&#182;</a>
              </div>
              <p>Log the incoming <code>CONTEXT_CHANGES_PENDING</code> message.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                        .ContextParticipantStreamResponse.ContextChangesPendingResponse contextChangesPending = value.getContextChangesPending();
                        logger.info(<span class="hljs-string">"Received CONTEXT_CHANGES_PENDING: "</span> + contextChangesPending.toString());</pre></div></div>
            
        </li>
        
        
        <li id="section-26">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-26">&#182;</a>
              </div>
              <p>Build an “accept” reply</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                        .ContextParticipantStreamRequest.ContextChangesPendingRequest.Builder changesPendingReplyBuilder = .ContextParticipantStreamRequest.ContextChangesPendingRequest
                                .newBuilder()
                                .setContextCoupon(contextChangesPending.getContextCoupon())
                                .setDecision(<span class="hljs-string">"accept"</span>);</pre></div></div>
            
        </li>
        
        
        <li id="section-27">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-27">&#182;</a>
              </div>
              <p>Add it to the queue</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                        requestQueue.offer(<span class="hljs-keyword">new</span> ActualRequestQueueItem(.ContextParticipantStreamRequest.newBuilder().setContextChangesPending(changesPendingReplyBuilder).build()));
                        <span class="hljs-keyword">break</span>;</pre></div></div>
            
        </li>
        
        
        <li id="section-28">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-28">&#182;</a>
              </div>
              <p>A reply for <code>AGENT_CONTEXT_CHANGES_PENDING</code> expected as well.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                    <span class="hljs-keyword">case</span> AGENT_CONTEXT_CHANGES_PENDING:</pre></div></div>
            
        </li>
        
        
        <li id="section-29">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-29">&#182;</a>
              </div>
              <p>Log then <code>AGENT_CONTEXT_CHANGES_PENDING</code> message.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                        .ContextParticipantStreamResponse.AgentContextChangesPendingResponse agentContextChangesPending = value.getAgentContextChangesPending();
                        logger.info(<span class="hljs-string">"Received AGENT_CONTEXT_CHANGES_PENDING: "</span> + agentContextChangesPending.toString());</pre></div></div>
            
        </li>
        
        
        <li id="section-30">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-30">&#182;</a>
              </div>
              <p>Build a reply with some return values</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                        .ContextParticipantStreamRequest.AgentContextChangesPendingRequest.Builder agentChangesReplyBuilder = .ContextParticipantStreamRequest.AgentContextChangesPendingRequest
                                .newBuilder()
                                .setAgentCoupon(agentContextChangesPending.getAgentCoupon())
                                .setContextCoupon(agentContextChangesPending.getContextCoupon())
                                .setDecision(<span class="hljs-string">"accept"</span>)
                                .addItemNames(<span class="hljs-string">"MyReturnValue"</span>).addItemValues(<span class="hljs-string">"foo"</span>);
                        requestQueue.offer(<span class="hljs-keyword">new</span> ActualRequestQueueItem(.ContextParticipantStreamRequest.newBuilder().setAgentContextChangesPending(agentChangesReplyBuilder).build()));
                        <span class="hljs-keyword">break</span>;</pre></div></div>
            
        </li>
        
        
        <li id="section-31">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-31">&#182;</a>
              </div>
              <p>We’ll handle the rest of the messages by logging to stdout.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                    <span class="hljs-keyword">case</span> CONTEXT_CHANGES_ACCEPTED:
                    <span class="hljs-keyword">case</span> CONTEXT_CHANGES_CANCELED:
                    <span class="hljs-keyword">case</span> COMMON_CONTEXT_TERMINATED:
                    <span class="hljs-keyword">case</span> PARTICIPANT_NOTIFICATION:
                    <span class="hljs-keyword">default</span>:
                        logger.info(<span class="hljs-string">"Received: "</span> + value.getContentCase().toString() + <span class="hljs-string">". With value: "</span> + value.toString());
                        <span class="hljs-keyword">break</span>;
                }
            }

            <span class="hljs-meta">@Override</span>
            <span class="hljs-function"><span class="hljs-keyword">public</span> <span class="hljs-keyword">void</span> <span class="hljs-title">onError</span><span class="hljs-params">(Throwable t)</span> </span>{
                logger.warning(<span class="hljs-string">"Error in stream: "</span> + t.getMessage());
                requestQueue.offer(<span class="hljs-keyword">new</span> TerminalRequestQueueItem(t));
            }

            <span class="hljs-meta">@Override</span>
            <span class="hljs-function"><span class="hljs-keyword">public</span> <span class="hljs-keyword">void</span> <span class="hljs-title">onCompleted</span><span class="hljs-params">()</span> </span>{
                requestQueue.offer(<span class="hljs-keyword">new</span> TerminalRequestQueueItem(<span class="hljs-keyword">null</span>));
            }
        });</pre></div></div>
            
        </li>
        
        
        <li id="section-32">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-32">&#182;</a>
              </div>
              <p>After the stream is setup we’ll send a regular JoinCommonContext invocation using the same stream.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        .JoinCommonContextRequest.Builder joinBuilder = .JoinCommonContextRequest
                .newBuilder()</pre></div></div>
            
        </li>
        
        
        <li id="section-33">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-33">&#182;</a>
              </div>
              <p>The application name should be an id of a registered application</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                .setApplicationName(applicationName)</pre></div></div>
            
        </li>
        
        
        <li id="section-34">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-34">&#182;</a>
              </div>
              <p>The participant should be an URL and since we’re using the streaming gRPC option it’s scheme must be <code>grpc</code></p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                .setParticipant(<span class="hljs-string">"grpc://"</span> + applicationName)</pre></div></div>
            
        </li>
        
        
        <li id="section-35">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-35">&#182;</a>
              </div>
              <p>The component identifier is used to select which context manager we’re joining</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                .setComponentIdentifier(componentId)</pre></div></div>
            
        </li>
        
        
        <li id="section-36">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-36">&#182;</a>
              </div>
              <p><code>survey = true</code> indicates we’re taking an active part in the context</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                .setSurvey(shouldSurvey)</pre></div></div>
            
        </li>
        
        
        <li id="section-37">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-37">&#182;</a>
              </div>
              <p><code>wait = true</code> indicates that we’re interested in waiting for any ongoing transactions to complete</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                .setWait(shouldWait);</pre></div></div>
            
        </li>
        
        
        <li id="section-38">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-38">&#182;</a>
              </div>
              <p>Send actual join context request.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        stream.onNext(.ContextParticipantStreamRequest.newBuilder().setJoinCommonContext(joinBuilder).build());</pre></div></div>
            
        </li>
        
        
        <li id="section-39">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-39">&#182;</a>
              </div>
              <p>We setup the consumer loop which takes items from the blocking queue and ships them across the stream.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        <span class="hljs-keyword">while</span>(<span class="hljs-keyword">true</span>) {</pre></div></div>
            
        </li>
        
        
        <li id="section-40">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-40">&#182;</a>
              </div>
              <p>Consume the queue of requests.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>            RequestQueueItem r = requestQueue.take();</pre></div></div>
            
        </li>
        
        
        <li id="section-41">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-41">&#182;</a>
              </div>
              <p>If we get a null value then we’re done.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>            <span class="hljs-keyword">if</span> (r <span class="hljs-keyword">instanceof</span> TerminalRequestQueueItem) <span class="hljs-keyword">break</span>;
            .ContextParticipantStreamRequest request = ((ActualRequestQueueItem) r).getRequest();
            logger.info(<span class="hljs-string">"Sending request: "</span>+request.toString());</pre></div></div>
            
        </li>
        
        
        <li id="section-42">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-42">&#182;</a>
              </div>
              <p>Ship the request on the stream.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>            stream.onNext(request);
        }

        logger.info(<span class="hljs-string">"Session is done for me"</span>);
    }</pre></div></div>
            
        </li>
        
        
        <li id="section-43">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-43">&#182;</a>
              </div>
              <h3 id="read-the-shared-context">Read the shared context</h3>
<p>This example demonstrates how to read the current value of all subjects in the shared context.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>    <span class="hljs-meta">@SuppressWarnings</span>(<span class="hljs-string">"Duplicates"</span>)
    <span class="hljs-meta">@CommandLine</span>.Command(mixinStandardHelpOptions = <span class="hljs-keyword">true</span>)
    <span class="hljs-function"><span class="hljs-keyword">public</span> <span class="hljs-keyword">void</span> <span class="hljs-title">ReadState</span><span class="hljs-params">(
            @CommandLine.Option(
                    names = {<span class="hljs-string">"--componentId"</span>},
                    required = <span class="hljs-keyword">true</span>,
                    description = <span class="hljs-string">"The id of the context manager to join"</span>
            )</span> String componentId,
            @CommandLine.<span class="hljs-title">Option</span><span class="hljs-params">(
                    names = {<span class="hljs-string">"--applicationName"</span>},
                    required = <span class="hljs-keyword">true</span>,
                    description = <span class="hljs-string">"The name identifying the application. This should be an identifier from the CMR."</span>
            )</span> String applicationName
    ) </span>{</pre></div></div>
            
        </li>
        
        
        <li id="section-44">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-44">&#182;</a>
              </div>
              <p>Get the necessary services.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        Seacow s = <span class="hljs-keyword">new</span> Seacow(host, port);
        ContextManagerGrpc.ContextManagerBlockingStub cm = s.getContextManager();
        ContextDataGrpc.ContextDataBlockingStub cd = s.getContextData();</pre></div></div>
            
        </li>
        
        
        <li id="section-45">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-45">&#182;</a>
              </div>
              <p>Construct and execute the join request. We’ll pretend we have a HTTP server running.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        .JoinCommonContextResponse joinResponse = cm.joinCommonContext(createScammingJoinRequest(componentId, applicationName));</pre></div></div>
            
        </li>
        
        
        <li id="section-46">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-46">&#182;</a>
              </div>
              <p>We’ll need to use the participant coupon.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        <span class="hljs-keyword">long</span> pc = joinResponse.getParticipantCoupon();</pre></div></div>
            
        </li>
        
        
        <li id="section-47">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-47">&#182;</a>
              </div>
              <p>Lets see which subjects are in the shared context.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        .GetItemNamesResponse namesResponse = cd.getItemNames(.GetItemNamesRequest
                .newBuilder()
                .setComponentIdentifier(componentId)</pre></div></div>
            
        </li>
        
        
        <li id="section-48">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-48">&#182;</a>
              </div>
              <p>-1 is a <em>secret</em> shortcut to MostRecentContextCoupon</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                .setContextCoupon(-<span class="hljs-number">1</span>)
                .build());</pre></div></div>
            
        </li>
        
        
        <li id="section-49">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-49">&#182;</a>
              </div>
              <p>Log all found names.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        logger.info(<span class="hljs-string">"Found "</span>+namesResponse.getNamesCount()+<span class="hljs-string">" names in the shared context"</span>);
        <span class="hljs-keyword">for</span> (String name : namesResponse.getNamesList()) {
            logger.info(<span class="hljs-string">"Name:"</span> +name);
        }</pre></div></div>
            
        </li>
        
        
        <li id="section-50">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-50">&#182;</a>
              </div>
              <p>Lets see which values are then stored for these names.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        .GetItemValuesResponse values = cd.getItemValues(.GetItemValuesRequest
                .newBuilder()
                .setComponentIdentifier(componentId)
                .setContextCoupon(-<span class="hljs-number">1</span>)
                .addAllItemNames(namesResponse.getNamesList())
                .build());</pre></div></div>
            
        </li>
        
        
        <li id="section-51">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-51">&#182;</a>
              </div>
              <p>Log all names and values. The resulting list is composed as <code>[name1, value1, name2, value2, ..., nameN, valueN]</code>.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        <span class="hljs-keyword">for</span> (String nameOrValue : values.getItemValuesList()) {
            logger.info(<span class="hljs-string">"NameOrValue:"</span> +nameOrValue);
        }
    }</pre></div></div>
            
        </li>
        
        
        <li id="section-52">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-52">&#182;</a>
              </div>
              <h3 id="write-to-the-shared-context">Write to the shared context</h3>
<p>Writing to the shared context is slightly involved as one must go through a complete context transaction to do so.
The steps involved here are:</p>
<ol>
<li>Join the common context.</li>
<li>Start a context transaction.</li>
<li>Specify the changes to make in the transaction.</li>
<li>End the transaction and check the results.</li>
<li>Publish the changes (commit or rollback).</li>
</ol>

            </div>
            
            <div class="content"><div class='highlight'><pre>    <span class="hljs-meta">@SuppressWarnings</span>(<span class="hljs-string">"Duplicates"</span>)
    <span class="hljs-meta">@CommandLine</span>.Command(mixinStandardHelpOptions = <span class="hljs-keyword">true</span>)
    <span class="hljs-function"><span class="hljs-keyword">public</span> <span class="hljs-keyword">void</span> <span class="hljs-title">WriteState</span><span class="hljs-params">(
            @CommandLine.Option(
                    names = {<span class="hljs-string">"--componentId"</span>},
                    required = <span class="hljs-keyword">true</span>,
                    description = <span class="hljs-string">"The id of the context manager to join"</span>
            )</span> String componentId,
            @CommandLine.<span class="hljs-title">Option</span><span class="hljs-params">(
                    names = {<span class="hljs-string">"--applicationName"</span>},
                    required = <span class="hljs-keyword">true</span>,
                    description = <span class="hljs-string">"The name identifying the application. This should be an identifier from the CMR."</span>
            )</span> String applicationName,
            @CommandLine.<span class="hljs-title">Option</span><span class="hljs-params">(
                    names = {<span class="hljs-string">"--state"</span>},
                    description = <span class="hljs-string">"The new state"</span>
            )</span> Map&lt;String, String&gt; state
    ) </span>{
        Seacow s = <span class="hljs-keyword">new</span> Seacow(host, port);
        ContextManagerGrpc.ContextManagerBlockingStub cm = s.getContextManager();
        ContextDataGrpc.ContextDataBlockingStub cd = s.getContextData();</pre></div></div>
            
        </li>
        
        
        <li id="section-53">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-53">&#182;</a>
              </div>
              <ol>
<li>Join the common context.</li>
</ol>

            </div>
            
            <div class="content"><div class='highlight'><pre>        .JoinCommonContextResponse joinResponse = cm.joinCommonContext(createScammingJoinRequest(componentId, applicationName));
        <span class="hljs-keyword">long</span> pc = joinResponse.getParticipantCoupon();</pre></div></div>
            
        </li>
        
        
        <li id="section-54">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-54">&#182;</a>
              </div>
              <ol start="2">
<li>Start the transaction.</li>
</ol>

            </div>
            
            <div class="content"><div class='highlight'><pre>        .StartContextChangesResponse startChangesResponse = cm.startContextChanges(.StartContextChangesRequest
                .newBuilder()
                .setComponentIdentifier(componentId)
                .setParticipantCoupon(pc)
                .build());</pre></div></div>
            
        </li>
        
        
        <li id="section-55">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-55">&#182;</a>
              </div>
              <p>We’ll need the coupon for the transaction for later.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        <span class="hljs-keyword">long</span> cc = startChangesResponse.getContextCoupon();</pre></div></div>
            
        </li>
        
        
        <li id="section-56">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-56">&#182;</a>
              </div>
              <ol start="3">
<li>Construct and execute a request to update the shared state</li>
</ol>

            </div>
            
            <div class="content"><div class='highlight'><pre>        cd.setItemValues(.SetItemValuesRequest
                .newBuilder()
                .setComponentIdentifier(componentId)
                .setContextCoupon(cc)
                .setParticipantCoupon(pc)
                .addAllItemNames(state.keySet())
                .addAllItemValues(state.values())
                .build()
        );</pre></div></div>
            
        </li>
        
        
        <li id="section-57">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-57">&#182;</a>
              </div>
              <ol start="4">
<li>End the transaction.</li>
</ol>

            </div>
            
            <div class="content"><div class='highlight'><pre>        .EndContextChangesResponse endResponse = cm.endContextChanges(.EndContextChangesRequest
                .newBuilder()
                .setComponentIdentifier(componentId)
                .setContextCoupon(cc)
                .build());</pre></div></div>
            
        </li>
        
        
        <li id="section-58">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-58">&#182;</a>
              </div>
              <p>Log the responses we get.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        <span class="hljs-keyword">for</span> (String response : endResponse.getResponsesList()) {
            logger.info(<span class="hljs-string">"Received response: "</span>+response);
        }</pre></div></div>
            
        </li>
        
        
        <li id="section-59">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-59">&#182;</a>
              </div>
              <ol start="5">
<li>Publish changes. For this example we’ll just always “accept”.</li>
</ol>

            </div>
            
            <div class="content"><div class='highlight'><pre>        cm.publishChangesDecision(.PublishChangesDecisionRequest
                .newBuilder()
                .setComponentIdentifier(componentId)
                .setContextCoupon(cc)
                .setDecision(<span class="hljs-string">"accept"</span>)
                .build());
    }</pre></div></div>
            
        </li>
        
        
        <li id="section-60">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-60">&#182;</a>
              </div>
              <h2 id="context-action-example">Context Action example</h2>

            </div>
            
        </li>
        
        
        <li id="section-61">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-61">&#182;</a>
              </div>
              <h3 id="perform-an-action">Perform an action</h3>
<p>You can request an action to be performed by the context manager. It will then route the request to the appropriate
action agent and return the result.
For this example we’ll use the blocking versions of the services and we’ll cheat a bit by using the HTTP mapping,
but wont setup an actual HTTP server to respond to the context managers requests. This means that we’ll get thrown off
the manager after a little while.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>    <span class="hljs-meta">@CommandLine</span>.Command(mixinStandardHelpOptions = <span class="hljs-keyword">true</span>)
    <span class="hljs-function"><span class="hljs-keyword">public</span> <span class="hljs-keyword">void</span> <span class="hljs-title">PerformAction</span><span class="hljs-params">(
            @CommandLine.Option(
                    names = {<span class="hljs-string">"--componentId"</span>},
                    required = <span class="hljs-keyword">true</span>,
                    description = <span class="hljs-string">"The id of the context manager to join"</span>
            )</span> String componentId,
            @CommandLine.<span class="hljs-title">Option</span><span class="hljs-params">(
                    names = {<span class="hljs-string">"--applicationName"</span>},
                    required = <span class="hljs-keyword">true</span>,
                    description = <span class="hljs-string">"The name identifying the application. This should be an identifier from the CMR."</span>
            )</span> String applicationName,
            @CommandLine.<span class="hljs-title">Option</span><span class="hljs-params">(
                    names = {<span class="hljs-string">"--action"</span>},
                    description = <span class="hljs-string">"The id of the action to perform"</span>,
                    required = <span class="hljs-keyword">true</span>
            )</span> String action,
            @CommandLine.<span class="hljs-title">Option</span><span class="hljs-params">(
                    names = {<span class="hljs-string">"--inputs"</span>},
                    description = <span class="hljs-string">"The inputs to provide to the action"</span>
            )</span>
            Map&lt;String, String&gt; inputs
            ) </span>{

        Seacow s = <span class="hljs-keyword">new</span> Seacow(host, port);</pre></div></div>
            
        </li>
        
        
        <li id="section-62">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-62">&#182;</a>
              </div>
              <p>Get a context manager service to be able to join the common context.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        ContextManagerGrpc.ContextManagerBlockingStub cm = s.getContextManager();</pre></div></div>
            
        </li>
        
        
        <li id="section-63">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-63">&#182;</a>
              </div>
              <p>Get a context action service to be able to perform actions.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        ContextActionGrpc.ContextActionBlockingStub ca = s.getContextAction();</pre></div></div>
            
        </li>
        
        
        <li id="section-64">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-64">&#182;</a>
              </div>
              <p>Pretend we have a HTTP server running.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        .JoinCommonContextRequest joinRequest = createScammingJoinRequest(componentId, applicationName);</pre></div></div>
            
        </li>
        
        
        <li id="section-65">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-65">&#182;</a>
              </div>
              <p>Join the common context. Only context participants are allowed to request actions to be performed.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        .JoinCommonContextResponse joinResponse = cm.joinCommonContext(joinRequest);
        logger.info(<span class="hljs-string">"Joined with: "</span>+joinResponse.toString());</pre></div></div>
            
        </li>
        
        
        <li id="section-66">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-66">&#182;</a>
              </div>
              <p>We’ll need the participant coupon when asking the context manager to perform an action.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        <span class="hljs-keyword">long</span> pc = joinResponse.getParticipantCoupon();</pre></div></div>
            
        </li>
        
        
        <li id="section-67">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-67">&#182;</a>
              </div>
              <p>Construct the request to have an action performed.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        .PerformRequest.Builder performRequestBuilder = .PerformRequest
                .newBuilder()
                .setComponentIdentifier(componentId)
                .setParticipantCoupon(pc)
                .setActionIdentifier(action);</pre></div></div>
            
        </li>
        
        
        <li id="section-68">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-68">&#182;</a>
              </div>
              <p>If the action needs an input to run we can also provide these in the request.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        <span class="hljs-keyword">if</span> (inputs != <span class="hljs-keyword">null</span> &amp;&amp; inputs.size() &gt; <span class="hljs-number">0</span>) {</pre></div></div>
            
        </li>
        
        
        <li id="section-69">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-69">&#182;</a>
              </div>
              <p>Iterate the provided inputs and add to request.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>            <span class="hljs-keyword">for</span> (String name : inputs.keySet()) {
                performRequestBuilder.addInputNames(name);
                performRequestBuilder.addInputValues(inputs.get(name));
            }
        }</pre></div></div>
            
        </li>
        
        
        <li id="section-70">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-70">&#182;</a>
              </div>
              <p>Execute the request.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        .PerformResponse performResponse = ca.perform(performRequestBuilder.build());
        logger.info(<span class="hljs-string">"Received a perform response: "</span> + performResponse.toString());</pre></div></div>
            
        </li>
        
        
        <li id="section-71">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-71">&#182;</a>
              </div>
              <p>We really need to execute a LeaveCommonContext but the context manager will figure out we’re gone after a while
so for this example we’ll be lazy.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>    }</pre></div></div>
            
        </li>
        
        
        <li id="section-72">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-72">&#182;</a>
              </div>
              <h2 id="utility-functions">Utility functions</h2>

            </div>
            
        </li>
        
        
        <li id="section-73">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-73">&#182;</a>
              </div>
              <p>Create “scamming” join request. The scam is that we’re not really running a context participant at <code>localhost:1234</code>.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>    <span class="hljs-keyword">private</span> .<span class="hljs-function">JoinCommonContextRequest <span class="hljs-title">createScammingJoinRequest</span><span class="hljs-params">(@CommandLine.Option(names = {<span class="hljs-string">"--componentId"</span>}, required = <span class="hljs-keyword">true</span>, description = <span class="hljs-string">"The id of the context manager to join"</span>)</span> String componentId, @CommandLine.<span class="hljs-title">Option</span><span class="hljs-params">(names = {<span class="hljs-string">"--applicationName"</span>}, required = <span class="hljs-keyword">true</span>, description = <span class="hljs-string">"The name identifying the application. This should be an identifier from the CMR."</span>)</span> String applicationName) </span>{
        <span class="hljs-keyword">return</span> .JoinCommonContextRequest
                .newBuilder()
                .setComponentIdentifier(componentId)
                .setApplicationName(applicationName)
                .setWait(<span class="hljs-keyword">true</span>)
                .setSurvey(<span class="hljs-keyword">true</span>)</pre></div></div>
            
        </li>
        
        
        <li id="section-74">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-74">&#182;</a>
              </div>
              <p>This endpoint is a scam.</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>                .setParticipant(<span class="hljs-string">"http://localhost:1234"</span>)
                .build();
    }

    <span class="hljs-meta">@Override</span>
    <span class="hljs-function"><span class="hljs-keyword">public</span> <span class="hljs-keyword">void</span> <span class="hljs-title">run</span><span class="hljs-params">()</span> </span>{</pre></div></div>
            
        </li>
        
        
        <li id="section-75">
            <div class="annotation">
              
              <div class="pilwrap ">
                <a class="pilcrow" href="#section-75">&#182;</a>
              </div>
              <p>Show help message if no sub-command is given</p>

            </div>
            
            <div class="content"><div class='highlight'><pre>        CommandLine.usage(<span class="hljs-keyword">new</span> RootCmd(), System.out);
    }
}</pre></div></div>
            
        </li>
        
    </ul>
  </div>
</body>
</html>
